%define anolis_release 5

%global openssl -openssl-linked
%global zstd 1
%global no_feature_statx -no-feature-statx
%global no_feature_renameat2 -no-feature-renameat2
%global no_feature_getentropy -no-feature-getentropy
%global qtchooser 1
%if 0%{?qtchooser}
%global priority 10
%endif

%global __brp_remove_la_files %nil
%global platform linux-g++

%if 0%{?use_clang}
%global platform linux-clang
%endif

%global qt_module qtbase
%global rpm_macros_dir %(d=%{_rpmconfigdir}/macros.d; [ -d $d ] || d=%{_sysconfdir}/rpm; echo $d)

%global journald -journald
%global examples 1

%global ibase -no-sql-ibase
%global tds -no-sql-tds
%global use_gold_linker -no-use-gold-linker

BuildRequires: make
BuildRequires: pkgconfig(libsystemd)

Name:    qt5-qtbase
Summary: Qt5 - QtBase components
Version: 5.15.11
Release: %{anolis_release}%{?dist}

License: LGPLv2 with exceptions or GPLv3 with exceptions
Url:     http://qt-project.org/
%global  majmin %(echo %{version} | cut -d. -f1-2)
Source0: https://download.qt.io/official_releases/qt/%{majmin}/%{version}/submodules/%{qt_module}-everywhere-opensource-src-%{version}.tar.xz

Source1: qtlogging.ini
Source6: 10-qt5-check-opengl2.sh
Source10: macros.%{name}
Patch0: add-loongarch64-support-for-qt5-qtbase.patch
Patch2: qtbase-multilib_optflags.patch
Patch3: qtbase-everywhere-src-5.15.6-private_api_warning.patch
Patch50: qtbase-opensource-src-5.8.0-QT_VERSION_CHECK.patch
Patch51: qtbase-hidpi_scale_at_192.patch
Patch52: qtbase-opensource-src-5.7.1-moc_macros.patch
Patch53: qtbase-everywhere-src-5.12.1-qt5gui_cmake_isystem_includes.patch
Patch54: qtbase-qmake_LFLAGS.patch
Patch55: qtbase-everywhere-src-5.14.2-no_relocatable.patch
Patch56: qtbase-everywhere-src-5.15.2-libglvnd.patch
Patch61: %{name}-cxxflag.patch
Patch63: %{name}-5.12.1-firebird.patch
Patch64: %{name}-5.12.1-firebird-4.0.0.patch
Patch65: qtbase-opensource-src-5.9.0-mysql.patch
Patch80: qtbase-use-wayland-on-gnome.patch
Patch90: %{name}-gcc11.patch

## upstream patches
# https://invent.kde.org/qt/qt/qtbase, kde/5.15 branch
# git diff v5.15.11-lts-lgpl..HEAD | gzip > kde-5.15-rollup-$(date +%Y%m%d).patch.gz
# patch100 in lookaside cache due to large'ish size -- rdieter
Patch100: kde-5.15-rollup-20231006.patch.gz

Patch101: qtbase-5.15.11-fix-missing-qtsan-include.patch
# Workaround for font rendering issue with cjk-vf-fonts
# https://bugreports.qt.io/browse/QTBUG-111994
# https://bugreports.qt.io/browse/QTBUG-112136
Patch102: qtbase-QTBUG-111994.patch
Patch103: qtbase-QTBUG-112136.patch
# IBus input method cannot set panel position correctly with DPI scaling
# https://bugreports.qt.io/browse/QTBUG-103393
Patch104: qtbase-QTBUG-103393.patch

Patch105: CVE-2023-51714.patch
Patch106: CVE-2024-25580-qtbase-5.15.patch
Patch107: CVE-2024-39936.patch
%global __requires_exclude_from ^%{_qt5_plugindir}/platformthemes/.*$
# filter plugin provides
%global __provides_exclude_from ^%{_qt5_plugindir}/.*\\.so$

%if 0%{?use_clang}
BuildRequires: clang >= 3.7.0
%else
BuildRequires: gcc-c++
%endif
%global dbus -dbus-linked
%global vulkan 1
BuildRequires: pkgconfig(vulkan)
%global egl 1
BuildRequires: libEGL-devel pkgconfig(gbm) pkgconfig(glesv2)
%global sqlite -system-sqlite
BuildRequires: pkgconfig(sqlite3) >= 3.7
%global harfbuzz -system-harfbuzz
BuildRequires: pkgconfig(harfbuzz) >= 0.9.42 pkgconfig(icu-i18n)
BuildRequires: pkgconfig(libpcre2-posix) >= 10.20 pkgconfig(libpcre) >= 8.0
%global pcre -system-pcre
BuildRequires: pkgconfig(xcb-xkb)
BuildRequires: pkgconfig(xcb) pkgconfig(xcb-glx) pkgconfig(xcb-icccm) pkgconfig(xcb-image) pkgconfig(xcb-keysyms) pkgconfig(xcb-renderutil)
BuildRequires: pkgconfig(zlib)  perl-generators python3 qt5-rpm-macros pkgconfig(xkeyboard-config)
BuildRequires: pkgconfig(xkbcommon-x11) >= 0.4.1 pkgconfig(xkbcommon) >= 0.4.1
BuildRequires: pkgconfig(xcb-util) pkgconfig(xcb-xkb) >= 1.10 pkgconfig(libinput)
BuildRequires: pkgconfig(libpulse) pkgconfig(libpulse-mainloop-glib) openssl-devel
BuildRequires: pkgconfig(libudev) pkgconfig(libpng) pkgconfig(ice) pkgconfig(sm)
BuildRequires: pkgconfig(libproxy-1.0) pkgconfig(gtk+-3.0) pkgconfig(glib-2.0)
BuildRequires: pkgconfig(gl) pkgconfig(fontconfig) pkgconfig(libdrm) pkgconfig(dbus-1)
BuildRequires: cups-devel desktop-file-utils findutils libjpeg-devel libmng-devel
BuildRequires: libtiff-devel pkgconfig(alsa) pkgconfig(atspi-2)

%if 0%{?tests}
BuildRequires: dbus-x11 mesa-dri-drivers time xorg-x11-server-Xvfb
%endif

%if 0%{?zstd}
BuildRequires: pkgconfig(libzstd)
%endif

%if 0%{?qtchooser}
Conflicts: qt < 1:4.8.6-10
Requires(post): %{_sbindir}/update-alternatives
Requires(postun): %{_sbindir}/update-alternatives
%endif
Requires: %{name}-common = %{version}-%{release}

%description
Qt is a software toolkit for developing applications.

This package contains base tools, like string, xml, and network
handling.

%package common
Summary: Common files for Qt5
Obsoletes: qt5-qtquick1 < 5.9.0
Obsoletes: qt5-qtquick1-devel < 5.9.0
%if "%{?ibase}" == "-no-sql-ibase"
Obsoletes: %{name}-ibase < %{version}-%{release}
%endif
%if "%{?tds}" == "-no-sql-tds"
Obsoletes: %{name}-tds < %{version}-%{release}
%endif
Requires: %{name} = %{version}-%{release}
BuildArch: noarch
%description common
%{summary}.

%package devel
Summary: Development files for %{name}
Requires: %{name} = %{version}-%{release}
Requires: %{name}-gui
%if 0%{?egl}
Requires: libEGL-devel
%endif
Requires: pkgconfig(gl)
%if 0%{?vulkan}
Requires: pkgconfig(vulkan)
%endif
Requires: qt5-rpm-macros
%if 0%{?use_clang}
Requires: clang >= 3.7.0
%endif
%description devel
%{summary}.

%package private-devel
Summary: Development files for %{name} private APIs
Obsoletes: %{name}-devel < 5.12.1-3
Requires: %{name}-devel = %{version}-%{release}
Requires: cups-devel
%description private-devel
%{summary}.

%package examples
Summary: Programming examples for %{name}
Requires: %{name} = %{version}-%{release}

%description examples
%{summary}.

%package static
Summary: Static library files for %{name}
Requires: %{name}-devel = %{version}-%{release}
Requires: pkgconfig(fontconfig) pkgconfig(glib-2.0) pkgconfig(libinput)
Requires: pkgconfig(xkbcommon) pkgconfig(zlib)

%description static
%{summary}.

%if "%{?ibase}" != "-no-sql-ibase"
%package ibase
Summary: IBase driver for Qt5's SQL classes
BuildRequires: firebird-devel
Requires: %{name} = %{version}-%{release}
%description ibase
%{summary}.
%endif

%package mysql
Summary: MySQL driver for Qt5's SQL classes
BuildRequires: mariadb-connector-c-devel
Requires: %{name} = %{version}-%{release}
%description mysql
%{summary}.

%package odbc
Summary: ODBC driver for Qt5's SQL classes
BuildRequires: unixODBC-devel
Requires: %{name} = %{version}-%{release}
%description odbc
%{summary}.

%package postgresql
Summary: PostgreSQL driver for Qt5's SQL classes
BuildRequires: libpq-devel
Requires: %{name} = %{version}-%{release}
%description postgresql
%{summary}.

%if "%{?tds}" != "-no-sql-tds"
%package tds
Summary: TDS driver for Qt5's SQL classes
BuildRequires: freetds-devel
Requires: %{name} = %{version}-%{release}
%description tds
%{summary}.
%endif

%package gui
Summary: Qt5 GUI-related libraries
Requires: %{name} = %{version}-%{release}
#Recommends: mesa-dri-drivers
Obsoletes: %{name}-x11 < 5.2.0
Provides:  %{name}-x11 = %{version}-%{release}
Requires: glx-utils
%description gui
Qt5 libraries used for drawing widgets and OpenGL items.


%prep
%setup -q -n %{qt_module}-everywhere-src-%{version}
 
%patch -P 0 -p1 -b .loongarch
%patch -P 3 -p1 -b .private_api_warning

%patch -P 50 -p1 -b .QT_VERSION_CHECK
%patch -P 52 -p1 -b .moc_macros
%patch -P 53 -p1 -b .qt5gui_cmake_isystem_includes
%patch -P 54 -p1 -b .qmake_LFLAGS
%patch -P 55 -p1 -b .no_relocatable
%patch -P 56 -p1 -b .libglvnd
%patch -P 61 -p1 -b .%{name}-cxxflag
%patch -P 64 -p1 -b .firebird
%patch -P 65 -p1 -b .mysql

%patch -P 80 -p1 -b .use-wayland-on-gnome.patch

%patch -P 90 -p1 -b .gcc11

%patch -P 100 -p1
%patch -P 101 -p1
%patch -P 102 -p1
%patch -P 103 -p1
%patch -P 104 -p1
%patch -P 105 -p1
%patch -P 106 -p1
%patch -P 107 -p1
pushd src/3rdparty
mkdir UNUSED
mv freetype libjpeg libpng zlib UNUSED/
%if "%{?sqlite}" == "-system-sqlite"
mv sqlite UNUSED/
%endif
%if "%{?xcb}" != "-qt-xcb"
mv xcb UNUSED/
%endif
popd

test -x configure || chmod +x configure

sed -i -e "s|^#!/usr/bin/env perl$|#!%{__perl}|" \
 bin/fixqt4headers.pl \
 bin/syncqt.pl \
 mkspecs/features/data/unix/findclasslist.pl


%build
%define _lto_cflags %{nil}

# remove -fexceptions
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed 's|-fexceptions||g'`
RPM_OPT_FLAGS="$RPM_OPT_FLAGS %{?qt5_arm_flag} %{?qt5_deprecated_flag} %{?qt5_null_flag}"

%if 0%{?use_clang}
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed 's|-fno-delete-null-pointer-checks||g'`
%endif

export MAKEFLAGS="%{?_smp_mflags}"
export LDFLAGS="$LDFLAGS $RPM_LD_FLAGS"
export CXXFLAGS="$CXXFLAGS $RPM_OPT_FLAGS"
export CFLAGS="$CFLAGS $RPM_OPT_FLAGS"

./configure \
  QMAKE_LFLAGS_RELEASE="${LDFLAGS:-$RPM_LD_FLAGS}" \
  QMAKE_CXXFLAGS_RELEASE="${CXXFLAGS:-$RPM_OPT_FLAGS}" \
  QMAKE_CFLAGS_RELEASE="${CFLAGS:-$RPM_OPT_FLAGS}" \
  %{?no_feature_getentropy} \
  %{?no_feature_statx} \
  %{?no_feature_renameat2} \
  -no-feature-relocatable \
  -no-directfb \
  %{?use_gold_linker} \
  -system-zlib \
  %{?xkbcommon} \
  %{?xcb} \
  %{?tds} \
  %{?sqlite} \
  %{?pcre} \
  %{?harfbuzz} \
  -system-libpng \
  -system-libjpeg \
  -no-strip \
  %{?no_sse2} \
  -no-separate-debug-info \
  -no-rpath \
  -no-reduce-relocations \
  -no-pch \
  %{!?tests:-nomake tests} \
  %{!?examples:-nomake examples} \
  %{?openssl} \
  -optimized-qmake \
  %{?journald} \
  -icu \
  %{?ibase} \
  -gtk \
  -glib \
  -fontconfig \
  %{?egl:-egl -eglfs} \
  %{?dbus}%{!?dbus:-dbus-runtime} \
  -accessibility \
  -shared \
  -release \
  -platform %{platform} \
  -translationdir %{_qt5_translationdir} \
  -sysconfdir %{_qt5_sysconfdir} \
  -plugindir %{_qt5_plugindir} \
  -importdir %{_qt5_importdir} \
  -headerdir %{_qt5_headerdir} \
  -examplesdir %{_qt5_examplesdir} \
  -docdir %{_qt5_docdir} \
  -datadir %{_qt5_datadir} \
  -libexecdir %{_qt5_libexecdir} \
  -libdir %{_qt5_libdir} \
  -bindir %{_qt5_bindir} \
  -archdatadir %{_qt5_archdatadir} \
  -prefix %{_qt5_prefix} \
  -opensource \
  -confirm-license \
  -verbose \

# Validate config results
for config_test in egl-x11 ; do
config_result="$(grep ^cache.${config_test}.result config.cache | cut -d= -f2 | tr -d ' ')"
if [ "${config_result}" != "true" ]; then
  echo "${config_test} detection failed"
  config_failed=1
fi
done
if [ ${config_failed} -eq 1 ]; then exit 1; fi

# ensure qmake build using optflags (which can happen if not munging qmake.conf defaults)
make clean -C qmake
%make_build -C qmake all binary \
  QMAKE_CFLAGS_RELEASE="${CFLAGS:-$RPM_OPT_FLAGS}" \
  QMAKE_CXXFLAGS_RELEASE="${CXXFLAGS:-$RPM_OPT_FLAGS}" \
  QMAKE_LFLAGS_RELEASE="${LDFLAGS:-$RPM_LD_FLAGS}" \
  QMAKE_STRIP=

%make_build


%install
make install INSTALL_ROOT=%{buildroot}

install -m644 -p -D %{SOURCE1} %{buildroot}%{_qt5_datadir}/qtlogging.ini

# Qt5.pc
cat >%{buildroot}%{_libdir}/pkgconfig/Qt5.pc<<EOF
translationdir=%{_qt5_translationdir}
sysconfdir=%{_qt5_sysconfdir}
settingsdir=%{_qt5_settingsdir}
qmake=%{_qt5_bindir}/qmake
plugindir=%{_qt5_plugindir}
moc=%{_qt5_bindir}/moc
libexecdir=%{_qt5_libexecdir}
libdir=%{_qt5_libdir}
importdir=%{_qt5_importdir}
headerdir=%{_qt5_headerdir}
examplesdir=%{_qt5_examplesdir}
docdir=%{_qt5_docdir}
datadir=%{_qt5_datadir}
bindir=%{_qt5_bindir}
archdatadir=%{_qt5_archdatadir}
prefix=%{_qt5_prefix}

Name: Qt5
Description: Qt5 Configuration
Version: %{version}
EOF

# rpm macros
install -p -m644 -D %{SOURCE10} \
  %{buildroot}%{rpm_macros_dir}/macros.%{name}

# create/own dirs
mkdir -p %{buildroot}{%{_qt5_archdatadir}/mkspecs/modules,%{_qt5_importdir},%{_qt5_libexecdir},%{_qt5_plugindir}/{designer,iconengines,script,styles},%{_qt5_translationdir}}
mkdir -p %{buildroot}%{_sysconfdir}/xdg/QtProject

sed -i \
  -e "s|@@NAME@@|%{name}|g" \
  -e "s|@@EPOCH@@|%{?epoch}%{!?epoch:0}|g" \
  -e "s|@@VERSION@@|%{version}|g" \
  -e "s|@@EVR@@|%{?epoch:%{epoch:}}%{version}-%{release}|g" \
  %{buildroot}%{rpm_macros_dir}/macros.%{name}

# hardlink files to {_bindir}, add -qt5 postfix to not conflict
mkdir %{buildroot}%{_bindir}
pushd %{buildroot}%{_qt5_bindir}
for i in * ; do
  case "${i}" in
    moc|qdbuscpp2xml|qdbusxml2cpp|qmake|rcc|syncqt|uic)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}-qt5
      ln -sv ${i} ${i}-qt5
      ;;
    *)
      ln -v  ${i} %{buildroot}%{_bindir}/${i}
      ;;
  esac
done
popd

# qtchooser conf
%if 0%{?qtchooser}
  mkdir -p %{buildroot}%{_sysconfdir}/xdg/qtchooser
  pushd    %{buildroot}%{_sysconfdir}/xdg/qtchooser
  echo "%{_qt5_bindir}" >  5-%{__isa_bits}.conf
## FIXME/TODO: verify qtchooser (still) happy if _qt5_prefix uses %%_prefix instead of %%_libdir/qt5
  echo "%{_qt5_prefix}" >> 5-%{__isa_bits}.conf
  # alternatives targets
  touch default.conf 5.conf
  popd
%endif

## .prl/.la file love
# nuke .prl reference(s) to %%buildroot, excessive (.la-like) libs
pushd %{buildroot}%{_qt5_libdir}
for prl_file in libQt5*.prl ; do
  sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" ${prl_file}
  if [ -f "$(basename ${prl_file} .prl).so" ]; then
    rm -fv "$(basename ${prl_file} .prl).la"
    sed -i -e "/^QMAKE_PRL_LIBS/d" ${prl_file}
  fi
done
popd

install -p -m755 -D %{SOURCE6} %{buildroot}%{_sysconfdir}/X11/xinit/xinitrc.d/10-qt5-check-opengl2.sh

# install privat headers for qtxcb
mkdir -p %{buildroot}%{_qt5_headerdir}/QtXcb
install -m 644 src/plugins/platforms/xcb/*.h %{buildroot}%{_qt5_headerdir}/QtXcb/

# drop Qt5Bootstrap from -static (#2017661)
rm -f %{buildroot}%{_qt5_libdir}/libQt5Bootstrap.*a
rm -f %{buildroot}%{_qt5_libdir}/libQt5Bootstrap.prl


%check
# verify Qt5.pc
export PKG_CONFIG_PATH=%{buildroot}%{_libdir}/pkgconfig
export CTEST_OUTPUT_ON_FAILURE=1
export PATH=%{buildroot}%{_qt5_bindir}:$PATH
export LD_LIBRARY_PATH=%{buildroot}%{_qt5_libdir}
test "$(pkg-config --modversion Qt5)" = "%{version}"
%if 0%{?tests}
dbus-launch --exit-with-session \
%make_build sub-tests  -k ||:
xvfb-run -a --server-args="-screen 0 1280x1024x32" \
dbus-launch --exit-with-session \
time \
make check -k ||:
%endif


%if 0%{?qtchooser}
%pre
if [ $1 -gt 1 ] ; then
%{_sbindir}/update-alternatives  \
  --remove qtchooser-qt5 \
  %{_sysconfdir}/xdg/qtchooser/qt5-%{__isa_bits}.conf >& /dev/null ||:

%{_sbindir}/update-alternatives  \
  --remove qtchooser-default \
  %{_sysconfdir}/xdg/qtchooser/qt5.conf >& /dev/null ||:
fi
%endif

%post
%if 0%{?qtchooser}
%{_sbindir}/update-alternatives \
  --install %{_sysconfdir}/xdg/qtchooser/5.conf \
  qtchooser-5 \
  %{_sysconfdir}/xdg/qtchooser/5-%{__isa_bits}.conf \
  %{priority}

%{_sbindir}/update-alternatives \
  --install %{_sysconfdir}/xdg/qtchooser/default.conf \
  qtchooser-default \
  %{_sysconfdir}/xdg/qtchooser/5.conf \
  %{priority}
%endif

%postun
%if 0%{?qtchooser}
if [ $1 -eq 0 ]; then
%{_sbindir}/update-alternatives  \
  --remove qtchooser-5 \
  %{_sysconfdir}/xdg/qtchooser/5-%{__isa_bits}.conf

%{_sbindir}/update-alternatives  \
  --remove qtchooser-default \
  %{_sysconfdir}/xdg/qtchooser/5.conf
fi
%endif

%files
%license LICENSE.FDL
%license LICENSE.GPL*
%license LICENSE.LGPL*
%if 0%{?qtchooser}
%dir %{_sysconfdir}/xdg/qtchooser
# not editable config files, so not using %%config here
%ghost %{_sysconfdir}/xdg/qtchooser/default.conf
%ghost %{_sysconfdir}/xdg/qtchooser/5.conf
%{_sysconfdir}/xdg/qtchooser/5-%{__isa_bits}.conf
%endif
%dir %{_sysconfdir}/xdg/QtProject/
%dir %{_qt5_plugindir}/designer/
%dir %{_qt5_plugindir}/generic/
%dir %{_qt5_plugindir}/iconengines/
%dir %{_qt5_plugindir}/imageformats/
%dir %{_qt5_plugindir}/platforminputcontexts/
%dir %{_qt5_plugindir}/platforms/
%dir %{_qt5_plugindir}/platformthemes/
%dir %{_qt5_plugindir}/printsupport/
%dir %{_qt5_plugindir}/script/
%dir %{_qt5_plugindir}/sqldrivers/
%dir %{_qt5_plugindir}/styles/
%{_qt5_libdir}/libQt5Concurrent.so.5*
%{_qt5_libdir}/libQt5Core.so.5*
%{_qt5_libdir}/libQt5DBus.so.5*
%{_qt5_libdir}/libQt5Network.so.5*
%{_qt5_libdir}/libQt5Sql.so.5*
%{_qt5_libdir}/libQt5Test.so.5*
%{_qt5_libdir}/libQt5Xml.so.5*
%dir %{_qt5_libdir}/cmake/
%dir %{_qt5_libdir}/cmake/Qt5/
%dir %{_qt5_libdir}/cmake/Qt5Concurrent/
%dir %{_qt5_libdir}/cmake/Qt5Core/
%dir %{_qt5_libdir}/cmake/Qt5DBus/
%dir %{_qt5_libdir}/cmake/Qt5Gui/
%dir %{_qt5_libdir}/cmake/Qt5Network/
%dir %{_qt5_libdir}/cmake/Qt5OpenGL/
%dir %{_qt5_libdir}/cmake/Qt5PrintSupport/
%dir %{_qt5_libdir}/cmake/Qt5Sql/
%dir %{_qt5_libdir}/cmake/Qt5Test/
%dir %{_qt5_libdir}/cmake/Qt5Widgets/
%dir %{_qt5_libdir}/cmake/Qt5Xml/
%dir %{_qt5_docdir}/
%{_qt5_docdir}/global/
%{_qt5_docdir}/config/
%{_qt5_importdir}/
%{_qt5_translationdir}/
%if "%{_qt5_prefix}" != "%{_prefix}"
%dir %{_qt5_prefix}/
%endif
%dir %{_qt5_archdatadir}/
%dir %{_qt5_datadir}/
%{_qt5_datadir}/qtlogging.ini
%dir %{_qt5_libexecdir}/
%dir %{_qt5_plugindir}/
%dir %{_qt5_plugindir}/bearer/
%{_qt5_plugindir}/bearer/libqconnmanbearer.so
%{_qt5_plugindir}/bearer/libqgenericbearer.so
%{_qt5_plugindir}/bearer/libqnmbearer.so
%{_qt5_libdir}/cmake/Qt5Network/Qt5Network_QConnmanEnginePlugin.cmake
%{_qt5_libdir}/cmake/Qt5Network/Qt5Network_QGenericEnginePlugin.cmake
%{_qt5_libdir}/cmake/Qt5Network/Qt5Network_QNetworkManagerEnginePlugin.cmake
%{_qt5_plugindir}/sqldrivers/libqsqlite.so
%{_qt5_libdir}/cmake/Qt5Sql/Qt5Sql_QSQLiteDriverPlugin.cmake

%files common
%{rpm_macros_dir}/macros.%{name}

%files devel
%if "%{_qt5_bindir}" != "%{_bindir}"
%dir %{_qt5_bindir}
%endif
%{_qt5_bindir}/qvkgen
%{_qt5_bindir}/fixqt4headers.pl
%{_qt5_bindir}/qlalr
%{_qt5_bindir}/uic*
%{_qt5_bindir}/syncqt*
%{_qt5_bindir}/rcc*
%{_qt5_bindir}/qmake*
%{_qt5_bindir}/qdbusxml2cpp*
%{_qt5_bindir}/qdbuscpp2xml*
%{_qt5_bindir}/moc*
%{_bindir}/tracegen
%{_bindir}/qvkgen
%{_bindir}/fixqt4headers.pl
%{_bindir}/qlalr
%{_bindir}/uic*
%{_bindir}/syncqt*
%{_bindir}/rcc*
%{_bindir}/qmake*
%{_bindir}/qdbusxml2cpp*
%{_bindir}/qdbuscpp2xml*
%{_bindir}/moc*
%if "%{_qt5_headerdir}" != "%{_includedir}"
%dir %{_qt5_headerdir}
%endif
%{_qt5_libdir}/pkgconfig/Qt5Xml.pc
%{_qt5_libdir}/pkgconfig/Qt5Widgets.pc
%{_qt5_libdir}/pkgconfig/Qt5Test.pc
%{_qt5_libdir}/pkgconfig/Qt5Sql.pc
%{_qt5_libdir}/pkgconfig/Qt5PrintSupport.pc
%{_qt5_libdir}/pkgconfig/Qt5OpenGL.pc
%{_qt5_libdir}/pkgconfig/Qt5Network.pc
%{_qt5_libdir}/pkgconfig/Qt5Gui.pc
%{_qt5_libdir}/pkgconfig/Qt5DBus.pc
%{_qt5_libdir}/pkgconfig/Qt5Core.pc
%{_qt5_libdir}/pkgconfig/Qt5Concurrent.pc
%{_qt5_libdir}/pkgconfig/Qt5.pc
%{_qt5_libdir}/metatypes/qt5widgets_metatypes.json
%{_qt5_libdir}/metatypes/qt5gui_metatypes.json
%{_qt5_libdir}/metatypes/qt5core_metatypes.json
%{_qt5_libdir}/cmake/Qt5XkbCommonSupport/
%{_qt5_libdir}/cmake/Qt5XcbQpa/
%{_qt5_libdir}/cmake/Qt5ThemeSupport/
%{_qt5_libdir}/cmake/Qt5ServiceSupport/
%{_qt5_libdir}/cmake/Qt5PlatformCompositorSupport/
%{_qt5_libdir}/cmake/Qt5LinuxAccessibilitySupport/
%{_qt5_libdir}/cmake/Qt5KmsSupport/
%{_qt5_libdir}/cmake/Qt5InputSupport/
%{_qt5_libdir}/cmake/Qt5GlxSupport/
%{_qt5_libdir}/cmake/Qt5FontDatabaseSupport/
%{_qt5_libdir}/cmake/Qt5FbSupport/
%{_qt5_libdir}/cmake/Qt5EventDispatcherSupport/
%{_qt5_libdir}/cmake/Qt5EglSupport/
%{_qt5_libdir}/cmake/Qt5EglFsKmsSupport/
%{_qt5_libdir}/cmake/Qt5EglFSDeviceIntegration/
%{_qt5_libdir}/cmake/Qt5EdidSupport/
%{_qt5_libdir}/cmake/Qt5DeviceDiscoverySupport/
%{_qt5_libdir}/cmake/Qt5AccessibilitySupport/
%{_qt5_libdir}/cmake/Qt5/Qt5ModuleLocation.cmake
%{_qt5_libdir}/cmake/Qt5Xml/Qt5XmlConfig*.cmake
%{_qt5_libdir}/cmake/Qt5Widgets/Qt5WidgetsMacros.cmake
%{_qt5_libdir}/cmake/Qt5Widgets/Qt5WidgetsConfig*.cmake
%{_qt5_libdir}/cmake/Qt5Test/Qt5TestConfig*.cmake
%{_qt5_libdir}/cmake/Qt5Sql/Qt5SqlConfig*.cmake
%{_qt5_libdir}/cmake/Qt5PrintSupport/Qt5PrintSupportConfig*.cmake
%{_qt5_libdir}/cmake/Qt5OpenGL/Qt5OpenGLConfig*.cmake
%{_qt5_libdir}/cmake/Qt5Network/Qt5NetworkConfig*.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5GuiConfig*.cmake
%{_qt5_libdir}/cmake/Qt5DBus/Qt5DBusMacros.cmake
%{_qt5_libdir}/cmake/Qt5DBus/Qt5DBusConfig*.cmake
%{_qt5_libdir}/cmake/Qt5Core/Qt5CTestMacros.cmake
%{_qt5_libdir}/cmake/Qt5Core/Qt5CoreMacros.cmake
%{_qt5_libdir}/cmake/Qt5Core/Qt5CoreConfig*.cmake
%{_qt5_libdir}/cmake/Qt5Concurrent/Qt5ConcurrentConfig*.cmake
%{_qt5_libdir}/cmake/Qt5/Qt5Config*.cmake
%{_qt5_libdir}/libQt5EglFSDeviceIntegration.so
%{_qt5_libdir}/libQt5EglFSDeviceIntegration.prl
%{_qt5_libdir}/libQt5Xml.so
%{_qt5_libdir}/libQt5Xml.prl
%{_qt5_libdir}/libQt5XcbQpa.so
%{_qt5_libdir}/libQt5XcbQpa.prl
%{_qt5_libdir}/libQt5Widgets.so
%{_qt5_libdir}/libQt5Widgets.prl
%{_qt5_libdir}/libQt5Test.so
%{_qt5_libdir}/libQt5Test.prl
%{_qt5_libdir}/libQt5Sql.so
%{_qt5_libdir}/libQt5Sql.prl
%{_qt5_libdir}/libQt5PrintSupport.so
%{_qt5_libdir}/libQt5PrintSupport.prl
%{_qt5_libdir}/libQt5OpenGL.so
%{_qt5_libdir}/libQt5OpenGL.prl
%{_qt5_libdir}/libQt5Network.so
%{_qt5_libdir}/libQt5Network.prl
%{_qt5_libdir}/libQt5Gui.so
%{_qt5_libdir}/libQt5Gui.prl
%{_qt5_libdir}/libQt5DBus.so
%{_qt5_libdir}/libQt5DBus.prl
%{_qt5_libdir}/libQt5Core.so
%{_qt5_libdir}/libQt5Core.prl
%{_qt5_libdir}/libQt5Concurrent.so
%{_qt5_libdir}/libQt5Concurrent.prl
%{_qt5_archdatadir}/mkspecs/
%{_qt5_headerdir}/QtXkbCommonSupport
%{_qt5_headerdir}/QtEdidSupport
%{_qt5_headerdir}/QtInputSupport
%{_qt5_headerdir}/QtEglFSDeviceIntegration
%{_qt5_headerdir}/QtXml/
%{_qt5_headerdir}/QtXcb/
%{_qt5_headerdir}/QtWidgets/
%{_qt5_headerdir}/QtTest/
%{_qt5_headerdir}/QtSql/
%{_qt5_headerdir}/QtPrintSupport/
%{_qt5_headerdir}/QtPlatformHeaders/
%{_qt5_headerdir}/QtOpenGL/
%{_qt5_headerdir}/QtNetwork/
%{_qt5_headerdir}/QtGui/
%{_qt5_headerdir}/QtDBus/
%{_qt5_headerdir}/QtCore/
%{_qt5_headerdir}/QtConcurrent/
%if 0%{?egl}
%{_qt5_libdir}/libQt5EglFsKmsSupport.prl
%{_qt5_libdir}/libQt5EglFsKmsSupport.so
%endif
%{_qt5_libdir}/qt5/bin/tracegen
%exclude %{_qt5_headerdir}/*/%{version}/

%files private-devel
%{_qt5_headerdir}/*/%{version}/
#{_qt5_archdatadir}/mkspecs/modules/qt_lib_*_private.pri

%files static
%{_qt5_libdir}/libQt5XkbCommonSupport.prl
%{_qt5_libdir}/libQt5XkbCommonSupport.*a
%{_qt5_libdir}/libQt5EdidSupport.prl
%{_qt5_libdir}/libQt5EdidSupport.*a
%{_qt5_headerdir}/QtKmsSupport
%{_qt5_libdir}/libQt5KmsSupport.prl
%{_qt5_libdir}/libQt5KmsSupport.*a
%{_qt5_headerdir}/QtThemeSupport
%{_qt5_libdir}/libQt5ThemeSupport.prl
%{_qt5_libdir}/libQt5ThemeSupport.*a
%{_qt5_headerdir}/QtServiceSupport
%{_qt5_libdir}/libQt5ServiceSupport.prl
%{_qt5_libdir}/libQt5ServiceSupport.*a
%{_qt5_headerdir}/QtPlatformCompositorSupport
%{_qt5_libdir}/libQt5PlatformCompositorSupport.prl
%{_qt5_libdir}/libQt5PlatformCompositorSupport.*a
%{_qt5_headerdir}/QtLinuxAccessibilitySupport
%{_qt5_libdir}/libQt5LinuxAccessibilitySupport.prl
%{_qt5_libdir}/libQt5LinuxAccessibilitySupport.*a
%{_qt5_libdir}/libQt5InputSupport.prl
%{_qt5_libdir}/libQt5InputSupport.*a
%{_qt5_headerdir}/QtGlxSupport
%{_qt5_libdir}/libQt5GlxSupport.prl
%{_qt5_libdir}/libQt5GlxSupport.*a
%{_qt5_headerdir}/QtFontDatabaseSupport
%{_qt5_libdir}/libQt5FontDatabaseSupport.prl
%{_qt5_libdir}/libQt5FontDatabaseSupport.*a
%{_qt5_headerdir}/QtFbSupport
%{_qt5_libdir}/libQt5FbSupport.prl
%{_qt5_libdir}/libQt5FbSupport.*a
%{_qt5_headerdir}/QtEventDispatcherSupport
%{_qt5_libdir}/libQt5EventDispatcherSupport.prl
%{_qt5_libdir}/libQt5EventDispatcherSupport.*a
%{_qt5_headerdir}/QtEglSupport
%{_qt5_libdir}/libQt5EglSupport.prl
%{_qt5_libdir}/libQt5EglSupport.*a
%{_qt5_headerdir}/QtDeviceDiscoverySupport
%{_qt5_libdir}/libQt5DeviceDiscoverySupport.prl
%{_qt5_libdir}/libQt5DeviceDiscoverySupport.*a
%{_qt5_headerdir}/QtAccessibilitySupport
%{_qt5_libdir}/libQt5AccessibilitySupport.prl
%{_qt5_libdir}/libQt5AccessibilitySupport.*a
%{_qt5_libdir}/pkgconfig/Qt5OpenGLExtensions.pc
%{_qt5_libdir}/cmake/Qt5OpenGLExtensions/
%{_qt5_libdir}/libQt5OpenGLExtensions.prl
%{_qt5_libdir}/libQt5OpenGLExtensions.*a
%{_qt5_headerdir}/QtOpenGLExtensions/
%if 0%{?vulkan}
%{_qt5_headerdir}/QtVulkanSupport/
%{_qt5_libdir}/cmake/Qt5VulkanSupport/
%{_qt5_libdir}/libQt5VulkanSupport.*a
%{_qt5_libdir}/libQt5VulkanSupport.prl
%endif

%if 0%{?examples}
%files examples
%{_qt5_examplesdir}/
%endif

%if "%{?ibase}" != "-no-sql-ibase"
%files ibase
%{_qt5_plugindir}/sqldrivers/libqsqlibase.so
%{_qt5_libdir}/cmake/Qt5Sql/Qt5Sql_QIBaseDriverPlugin.cmake
%endif

%files mysql
%{_qt5_plugindir}/sqldrivers/libqsqlmysql.so
%{_qt5_libdir}/cmake/Qt5Sql/Qt5Sql_QMYSQLDriverPlugin.cmake

%files odbc
%{_qt5_plugindir}/sqldrivers/libqsqlodbc.so
%{_qt5_libdir}/cmake/Qt5Sql/Qt5Sql_QODBCDriverPlugin.cmake

%files postgresql
%{_qt5_plugindir}/sqldrivers/libqsqlpsql.so
%{_qt5_libdir}/cmake/Qt5Sql/Qt5Sql_QPSQLDriverPlugin.cmake

%if "%{?tds}" != "-no-sql-tds"
%files tds
%{_qt5_plugindir}/sqldrivers/libqsqltds.so
%{_qt5_libdir}/cmake/Qt5Sql/Qt5Sql_QTDSDriverPlugin.cmake
%endif

%ldconfig_scriptlets gui

%files gui
%dir %{_sysconfdir}/X11/xinit
%dir %{_sysconfdir}/X11/xinit/xinitrc.d/
%{_sysconfdir}/X11/xinit/xinitrc.d/10-qt5-check-opengl2.sh
%{_qt5_libdir}/libQt5Gui.so.5*
%{_qt5_libdir}/libQt5OpenGL.so.5*
%{_qt5_libdir}/libQt5PrintSupport.so.5*
%{_qt5_libdir}/libQt5Widgets.so.5*
%{_qt5_libdir}/libQt5XcbQpa.so.5*
%{_qt5_plugindir}/generic/libqevdevkeyboardplugin.so
%{_qt5_plugindir}/generic/libqevdevmouseplugin.so
%{_qt5_plugindir}/generic/libqevdevtabletplugin.so
%{_qt5_plugindir}/generic/libqevdevtouchplugin.so
%{_qt5_plugindir}/generic/libqlibinputplugin.so
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QLibInputPlugin.cmake
%{_qt5_plugindir}/generic/libqtuiotouchplugin.so
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QEvdevKeyboardPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QEvdevMousePlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QEvdevTabletPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QEvdevTouchScreenPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QTuioTouchPlugin.cmake
%{_qt5_plugindir}/imageformats/libqgif.so
%{_qt5_plugindir}/imageformats/libqico.so
%{_qt5_plugindir}/imageformats/libqjpeg.so
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QGifPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QICOPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QJpegPlugin.cmake
%{_qt5_plugindir}/platforminputcontexts/libcomposeplatforminputcontextplugin.so
%{_qt5_plugindir}/platforminputcontexts/libibusplatforminputcontextplugin.so
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QComposePlatformInputContextPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QIbusPlatformInputContextPlugin.cmake
%{_qt5_libdir}/cmake/Qt5PrintSupport/Qt5PrintSupport_QCupsPrinterSupportPlugin.cmake
%{_qt5_plugindir}/printsupport/libcupsprintersupport.so
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QGtk3ThemePlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QXdgDesktopPortalThemePlugin.cmake
%{_qt5_plugindir}/platformthemes/libqgtk3.so
%{_qt5_plugindir}/platformthemes/libqxdgdesktopportal.so
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QXcbGlxIntegrationPlugin.cmake
%{_qt5_plugindir}/xcbglintegrations/libqxcb-glx-integration.so
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QXcbIntegrationPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QVncIntegrationPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QOffscreenIntegrationPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QMinimalIntegrationPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QLinuxFbIntegrationPlugin.cmake
%{_qt5_plugindir}/platforms/libqvnc.so
%{_qt5_plugindir}/platforms/libqxcb.so
%{_qt5_plugindir}/platforms/libqoffscreen.so
%{_qt5_plugindir}/platforms/libqminimal.so
%{_qt5_plugindir}/platforms/libqlinuxfb.so
%if 0%{?egl}
%{_qt5_libdir}/libQt5EglFSDeviceIntegration.so.5*
%{_qt5_libdir}/libQt5EglFsKmsSupport.so.5*
%{_qt5_plugindir}/platforms/libqeglfs.so
%{_qt5_plugindir}/platforms/libqminimalegl.so
%dir %{_qt5_plugindir}/egldeviceintegrations/
%{_qt5_plugindir}/egldeviceintegrations/libqeglfs-kms-integration.so
%{_qt5_plugindir}/egldeviceintegrations/libqeglfs-x11-integration.so
%{_qt5_plugindir}/xcbglintegrations/libqxcb-egl-integration.so
%{_qt5_plugindir}/egldeviceintegrations/libqeglfs-kms-egldevice-integration.so
%{_qt5_plugindir}/egldeviceintegrations/libqeglfs-emu-integration.so
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QMinimalEglIntegrationPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QEglFSIntegrationPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QEglFSX11IntegrationPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QEglFSKmsGbmIntegrationPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QXcbEglIntegrationPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QEglFSKmsEglDeviceIntegrationPlugin.cmake
%{_qt5_libdir}/cmake/Qt5Gui/Qt5Gui_QEglFSEmulatorIntegrationPlugin.cmake
%endif


%changelog
* Wed Nov 20 2024 Yuki Zhu <zhuyujie01@inspur.com> - 5.15.11-5
- fix CVE-2024-33936
* Tue Jun 04 2024 yangxianzhao <yangxianzhao@uniontech.com> - 5.15.11-4
- fix CVE-2024-25580

* Mon Jan 22 2024 Chang Gao <gc-taifu@linux.alibaba.com> - 5.15.11-3
- Rebuild because of files modified time are incorrect

* Fri Jan 05 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 5.15.11-2
- fix CVE-2023-51714

* Sat Oct 07 2023 Funda Wang <fundawang@yeah.net> - 5.15.11-1
- 5.15.11

* Wed Aug 16 2023 Wenlong Zhang <zhangwenlong@loongson.cn> - 5.15.9-3
- add loongarch64 support for qt5-qtbase

* Tue Jun 06 2023 Funda Wang <fundawang@yeah.net> - 5.15.9-2
- Fix CVE-2023-33285 & CVE-2023-34410

* Mon Apr 17 2023 Funda Wang <fundawang@yeah.net> - 5.15.9-1
- New version 5.15.9

* Mon Apr 17 2023 Zhongling He <zhonglingh@linux.alibaba.com> - 5.15.8-5
- refactor rpm spec

* Tue Mar 28 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 5.15.8-4
- Del Specific Fields

* Sat Mar 4 2023 Funda Wang <fundawang@yeah.net> - 5.15.8-3
- Rebuild for new libpq

* Wed Feb 8 2023 Funda Wang <fundawang@yeah.ent> - 5.15.8-2
- Fix possible DOS involving the Qt SQL ODBC driver plugin
  CVE-2023-24607

* Tue Jan 10 2023 Funda Wang <fundawang@yeah.ent> - 5.15.8-1
- New version 5.15.8

* Wed Dec 7 2022 Funda Wang <fundawang@yeah.ent> - 5.15.7-1
- New version 5.15.7

* Tue Dec 06 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 5.15.5-2
- rebuild with icu update

* Wed Jul 27 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 5.15.5-1
- update to 5.15.5

* Tue Jul 26 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 5.15.3-2
- remove dependency of qt_settings

* Tue Apr 26 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 5.15.3-1
- init from upstream
